/***************************************************************************
 *   Copyright (C) 2008 by Aris Kosmopoulos   *
 *   akosmo@iit.demokritos.gr   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _ATTRIBUTE_H_
#define _ATTRIBUTE_H_
#include <string>
#include <vector>
using namespace std;

class Attribute
{
public:
       //attribute id
       int id;
       //times attribute appears in spam texts
       unsigned int totalHamSequence;
       //times attribute appears in spam texts
       unsigned int  totalSpamSequence;
       //number of Spam messages that contain the attribute
       int spamTotalCarrier;
       //number of Ham messages that contain the attribute
       int hamTotalCarrier;
       //name of the file that we last saw this attribute
       
       //Information Gain of the attribute
       double IG;
       //statistic mean of attribute in ham messages 
       double Mham;
       //statistic mean of attribute in spam messages 
       double Mspam;
       //Typical deviation of attribute in ham messages 
       double Sham;
       //Typical deviation of attribute in spam messages 
       double Sspam;
       //This "possibility is only used for Paul Graham's spam filter"
       double P_Graham;
       
       //vector that holds the frequencies of this attribute for each ham Message
       //vector<int> hamFrequencies;
       //vector that holds the normalized frequencies of this attribute for each ham Message
       //vector<double> hamFrequenciesNorm;
       //vector that holds the TFIDF frequencies of this attribute for each ham Message
       //vector<double> hamFrequenciesTFIDF;
       
       //vector that holds the frequencies of this attribute for each spam Message
       //vector<int> spamFrequencies;
       //vector that holds the normalized frequencies of this attribute for each spam Message
       //vector<double> spamFrequenciesNorm;
       //vector that holds the TFIDF frequencies of this attribute for each spam Message
       //vector<double> spamFrequenciesTFIDF;
       
       //attribute used for classification
       //bool active;
       bool seenBefore;

			 bool removed;
       Attribute(int id);
       Attribute(int id, unsigned int totalHamSequence,unsigned int  totalSpamSequence, int spamTotalCarrier, int hamTotalCarrier);
       Attribute();
       ~Attribute();
};

#endif
