/***************************************************************************
 *   Copyright (C) 2008 by Aris Kosmopoulos   *
 *   akosmo@iit.demokritos.gr   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _ATTRIBUTECOLLECTION_H_
#define _ATTRIBUTECOLLECTION_H_

#include <map>
#include <vector>
#include <iostream>
#include <math.h>
#include <algorithm>
#include <fstream>
#include <sstream>
#include "attribute.h"

class AttributeCollection
{
private:
        //A map with all atrributes
        map<int,Attribute> collection;
	//A multimap of IG and id
	multimap<double,int> collectionIG;

	//A map iterator that remembers the last seen Attribute
	map<int,Attribute>::iterator pointerIterator;
				//A map iterator that remembers the last seen Attribute
        multimap<double,int>::iterator pointerIGIdIterator;

        //integer that remembers the last aksed Attribute with the getAttributeAt(int i) function
        int lastSeenAttribute;
        
        Attribute* attributePointer;
public:
				//size of map
				int size;
        //counts the number of different attributes that at appear at spam messages 
        int spamAttributesCounter;
        //counts the number of different attributes that at appear at ham messages
        int hamAttributesCounter;
				//indicates that collectionIG multimap is ready for use;
				bool collectionIGReady;
public:
       AttributeCollection ();
       ~AttributeCollection();
       Attribute& getAttributeAt(int i,bool& flag);
			 Attribute& getAttributeAt(int i);
			 void reset();
       bool getAttribute(int id,Attribute& att);
       void removeAttributes(vector<int> att_tobe_deleted);
       void addAttribute (int id,bool spam,int sumOfTokens);
       //void copyAttribute (int id, unsigned int totalHamSequence, unsigned int totalSpamSequence, int spamTotalCarrier, int hamTotalCarrier,double IG,vector<int>& hamFrequencies,vector<int>& spamFrequencies,vector<double>& hamFrequenciesNorm,vector<double>& spamFrequenciesNorm,vector<double>& hamFrequenciesTFIDF,vector<double>& spamFrequenciesTFIDF);
       //void computeStatisticVariables(int sumOfHamMessages,int sumOfSpamMessages,bool normalized);
       void addAttributeIGId (double IG, int id);
       void computeP_Graham(int sumOfHamMessages,int sumOfSpamMessages);
       int numberOfAttributes();
       void fixSize(int m);
       void printAttributes();
       void clear();
       void getAttributesFromFile(string nameOffile,map<string,int>& coder,int& sumOfHamMessages,int& sumOfSpamMessages,int& lastUsedCode);
       void writeAttributesToFile(string nameOffile,map<string,int>& coder,int sumOfHamMessages,int sumOfSpamMessages,int last_used_code);
       vector<string> getTokens(const string& var, const string& sSeparators);
       void printInfo()
	{
		cout << this->numberOfAttributes() << "BIG = "  << collection.size() << "AIG = " << collectionIG.size() << endl;
	}


};

#endif
