/***************************************************************************
 *   Copyright (C) 2008 by Aris Kosmopoulos   *
 *   akosmo@iit.demokritos.gr   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _EMAILPARSER_H_
#define _EMAILPARSER_H_
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include "base64.h"

using namespace std;

class EmailParser
{
	private:
	bool base64;
	bool quotedP;
	bool inTag;
	bool inScript;
public:	
	EmailParser (string inputMessageName, stringstream& finalStream, bool parserOn); 
	~EmailParser (); 
private:
	void parseHeader(stringstream& fout,ifstream& fin);
	void parseText (stringstream& fout,ifstream& fin);
	bool parseInfo (stringstream& fout,ifstream& fin);
	void writeText (stringstream& fout,string& line);
	bool isNumber(char ch);
	bool isDex(char ch);
	void removeHTML(stringstream& fout,string& line);
	string& replaceAll(string& context, const string& from, const string& to); 
};
#endif
